﻿
using IsolationFrameworkDemo.Services;

using StructureMap;
using StructureMap.Configuration.DSL;

namespace IsolationFrameworkDemo
{
    public class IocRegistry : Registry
    {
        protected override void configure()
        {

            ForRequestedType<IUserLoginService>(). 
                TheDefaultIsConcreteType<UserLoginService>();

            ForRequestedType<IUserRepository>()
                .TheDefaultIsConcreteType<UserRepository>();

            ForRequestedType<IChallangeValidator>()
                .TheDefaultIsConcreteType<ChallangeValidator>();

            ForRequestedType<IEmailGateway>()
                .TheDefaultIsConcreteType<EmailGateway>();
            

        }
    }

    public class FooRegistry: Registry
    {
        
    }

    public class IoCBootstrap
    {

        public static void SetupRegistriesForIoC()
        {
            ObjectFactory.Initialize(
                scanner =>
                    {
                        scanner.AddRegistry( new IocRegistry() );
                        scanner.AddRegistry( new FooRegistry() );

                    }
                );



        }

    }
}
